#include "node.h"
#include <iostream>

node::node(link_t init_link,
		data_t init_data)
{
	data = init_data;
	next = init_link;
}

int list_lenght(node::link_t head_ptr){
	int counter = 0;
	for (node::link_t cursor = head_ptr;
		cursor != NULL;
		cursor = cursor->next){
		counter++;
	}
	return counter;
}

void list_head_insert(node::link_t & head_ptr,
						node::data_t entry){
	head_ptr = new node(head_ptr, entry);
}

void list_insert(node::link_t & prev_ptr,
				node::data_t entry){
	//prev_ptr->next = new node(prev_ptr->next, entry);
	node::link_t insert_ptr = new node(prev_ptr->next, entry);
	prev_ptr->next = insert_ptr;
}

void list_head_remove(node::link_t & head_ptr){
	node::link_t remove_ptr = head_ptr;
	head_ptr = head_ptr->next;
	delete remove_ptr;
}

void list_remove(node::link_t & prev_ptr){
	node::link_t remove_ptr = prev_ptr->next;
	prev_ptr->next = remove_ptr->next;
	delete remove_ptr;
}

void list_clear(node::link_t & head_ptr){
	while(head_ptr != NULL)
		list_head_remove(head_ptr);
}

node::link_t list_search(node::link_t & head_ptr,
						node::data_t target){

	for (node::link_t cursor = head_ptr;
		cursor != NULL;
		cursor = cursor->next){
		if (cursor->data == target)
			return cursor;
	}
	return NULL;
}

void apply(node::link_t head_ptr, 
			void fnc(node::data_t & data)){
	
	for (node::link_t cursor = head_ptr;
		cursor != NULL;
		cursor = cursor->next){
			fnc(cursor->data);
	}
}
void print_node_data(node::data_t & data){
	std::cout << data << std::endl;	
}

void print_list(node::link_t head_ptr){
	if (head_ptr == NULL){
		std::cout << "Liste Bos" << std::endl;
		return;
	}
	
	apply(head_ptr, print_node_data);
}